{% extends '@DemosPlanCore/DemosPlanCore/base.html.twig' %}

{% block component_part %}
    <h1>
        {{ "procedure.new"|trans }}
    </h1>
    {% if hasPermission('feature_procedure_templates') %}
        {% set masterBlueprintId = templateVars.masterTemplateId %}
        {% set copyMasterOptions = [{ label: 'master.empty', value: masterBlueprintId, isMaster: true }] %}
        {% if templateVars.list.procedures is defined %}
            {% for procedure in templateVars.list.procedures %}
                {% set copyMasterOptions = copyMasterOptions|merge([{ label: procedure.name|default('----'), value: procedure.ident|default('----') }]) %}
            {% endfor %}
        {% endif %}
    {% endif %}

    <p class="u-mb">{{ "text.procedure.new"|trans }}</p>

    {% set procedureTypes = templateVars.procedureTypes|map(el => { name: el.name, id: el.id, description: el.description }) %}

    {#  To correctly inform planners about which fields are inherited from the selected procedure template,
        all fields activated in a certain project are passed to the respective translation string. #}
    {% set procedureTemplateFields = [
        { name: 'planningagency', active: hasPermission('field_procedure_adjustments_planning_agency') },
        { name: 'authorized.users', active: hasProcedureUserRestrictedAccess and hasPermission('feature_procedure_user_restrict_access_edit') },
        { name: 'internalnote', active: true },
        { name: 'email.procedure.agency', active:  true },
        { name: 'email.address.more', active: true },
        { name: 'procedure.pictogram', active: hasPermission(['field_procedure_pictogram', 'area_public_participation']) },
        { name: 'linkbox', active: hasPermission('field_procedure_linkbox') },
        { name: 'public.participation.contact', active: hasPermission('field_procedure_contact_person') },
        { name: 'procedure.notifyCountry', active: hasPermission('feature_statement_notify_counties') }
    ]|filter(field => field.active)|map(field => field.name|trans)|join(', ') %}

    <dp-new-procedure
        {% if copyMasterOptions is defined and masterBlueprintId is defined %}
            :procedure-template-hint="Translator.trans('procedure.template.fields', { fields: JSON.parse('{{ procedureTemplateFields|json_encode|e('js', 'utf-8') }}') })"
            :blueprint-options="JSON.parse('{{ copyMasterOptions|json_encode|e('js', 'utf-8') }}')"
            master-blueprint-id="{{ masterBlueprintId }}"
        {% endif %}
        :procedure-types="JSON.parse('{{ procedureTypes|json_encode|e('js', 'utf-8') }}')"
        token="{{ form._token.vars.value }}"
        :token-length="{{ constant('demosplan\\DemosPlanCoreBundle\\Entity\\Procedure\\ProcedureCoupleToken::TOKEN_LENGTH') }}">
    </dp-new-procedure>
{% endblock component_part %}

{% block javascripts %}
    {{ parent() }}
    {{ webpackBundles(['procedure-administrationNew.js']) }}
{% endblock javascripts %}
